package b4a.HC05LightDimmer;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;
    public static boolean dontPause;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.HC05LightDimmer", "b4a.HC05LightDimmer.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.HC05LightDimmer", "b4a.HC05LightDimmer.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.HC05LightDimmer.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        if (!dontPause)
            BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        else
            BA.LogInfo("** Activity (main) Pause event (activity is not paused). **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        if (!dontPause) {
            processBA.setActivityPaused(true);
            mostCurrent = null;
        }

        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.ToggleButtonWrapper _tbtled = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstatus = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnconnect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnup = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndown = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnright = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnleft = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _up = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _down = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _right = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _left = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmessage = null;
public anywheresoftware.b4a.objects.ProgressBarWrapper _progressbar1 = null;
public static String _status = "";
public b4a.HC05LightDimmer.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 31;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 //BA.debugLineNum = 32;BA.debugLine="Up.Target = btnUp";
mostCurrent._up.Target = (Object)(mostCurrent._btnup.getObject());
 //BA.debugLineNum = 33;BA.debugLine="Up.SetOnTouchListener(\"Up_OnTouch\")";
mostCurrent._up.SetOnTouchListener(processBA,"Up_OnTouch");
 //BA.debugLineNum = 34;BA.debugLine="Down.Target = btnDown";
mostCurrent._down.Target = (Object)(mostCurrent._btndown.getObject());
 //BA.debugLineNum = 35;BA.debugLine="Down.SetOnTouchListener(\"Down_OnTouch\")";
mostCurrent._down.SetOnTouchListener(processBA,"Down_OnTouch");
 //BA.debugLineNum = 36;BA.debugLine="Right.Target = btnRight";
mostCurrent._right.Target = (Object)(mostCurrent._btnright.getObject());
 //BA.debugLineNum = 37;BA.debugLine="Right.SetOnTouchListener(\"Right_OnTouch\")";
mostCurrent._right.SetOnTouchListener(processBA,"Right_OnTouch");
 //BA.debugLineNum = 38;BA.debugLine="Left.Target = btnLeft";
mostCurrent._left.Target = (Object)(mostCurrent._btnleft.getObject());
 //BA.debugLineNum = 39;BA.debugLine="Left.SetOnTouchListener(\"Left_OnTouch\")";
mostCurrent._left.SetOnTouchListener(processBA,"Left_OnTouch");
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 46;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 47;BA.debugLine="If UserClosed = True And Status = \"connected\" The";
if (_userclosed==anywheresoftware.b4a.keywords.Common.True && (mostCurrent._status).equals("connected")) { 
 //BA.debugLineNum = 48;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(0";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{(byte) (0)}));
 };
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 43;BA.debugLine="SetState";
_setstate();
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _btnconnect_click() throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub btnConnect_Click";
 //BA.debugLineNum = 83;BA.debugLine="CallSub(Starter, \"Connect\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._starter.getObject()),"Connect");
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static boolean  _down_ontouch(Object _viewtag,int _action,float _x,float _y,Object _motionevent) throws Exception{
String _b = "";
 //BA.debugLineNum = 104;BA.debugLine="Sub Down_OnTouch( viewtag As Object, action As Int";
 //BA.debugLineNum = 105;BA.debugLine="Select action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 107;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 108;BA.debugLine="b=\"DOWN\"";
_b = "DOWN";
 //BA.debugLineNum = 109;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
case 1: {
 //BA.debugLineNum = 111;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 112;BA.debugLine="b=\"OFF\"";
_b = "OFF";
 //BA.debugLineNum = 113;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
}
;
 //BA.debugLineNum = 115;BA.debugLine="btnDown.Invalidate";
mostCurrent._btndown.Invalidate();
 //BA.debugLineNum = 116;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return false;
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Private tbtLED As ToggleButton";
mostCurrent._tbtled = new anywheresoftware.b4a.objects.CompoundButtonWrapper.ToggleButtonWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Private lblStatus As Label";
mostCurrent._lblstatus = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Private btnConnect, btnUp, btnDown, btnRight, btn";
mostCurrent._btnconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnup = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btndown = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnright = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnleft = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Private Up, Down, Right, Left As Reflector";
mostCurrent._up = new anywheresoftware.b4a.agraham.reflection.Reflection();
mostCurrent._down = new anywheresoftware.b4a.agraham.reflection.Reflection();
mostCurrent._right = new anywheresoftware.b4a.agraham.reflection.Reflection();
mostCurrent._left = new anywheresoftware.b4a.agraham.reflection.Reflection();
 //BA.debugLineNum = 24;BA.debugLine="Private lblMessage As Label";
mostCurrent._lblmessage = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Private ProgressBar1 As ProgressBar";
mostCurrent._progressbar1 = new anywheresoftware.b4a.objects.ProgressBarWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private Status As String";
mostCurrent._status = "";
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static boolean  _left_ontouch(Object _viewtag,int _action,float _x,float _y,Object _motionevent) throws Exception{
String _b = "";
 //BA.debugLineNum = 136;BA.debugLine="Sub Left_OnTouch( viewtag As Object, action As Int";
 //BA.debugLineNum = 137;BA.debugLine="Select action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 139;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 140;BA.debugLine="b=\"LEFT\"";
_b = "LEFT";
 //BA.debugLineNum = 141;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
case 1: {
 //BA.debugLineNum = 143;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 144;BA.debugLine="b=\"OFF\"";
_b = "OFF";
 //BA.debugLineNum = 145;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
}
;
 //BA.debugLineNum = 147;BA.debugLine="btnLeft.Invalidate";
mostCurrent._btnleft.Invalidate();
 //BA.debugLineNum = 148;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 149;BA.debugLine="End Sub";
return false;
}
public static String  _messagefromdevice(String _msg) throws Exception{
 //BA.debugLineNum = 68;BA.debugLine="Public Sub MessageFromDevice(msg As String)";
 //BA.debugLineNum = 69;BA.debugLine="lblMessage.Text = msg";
mostCurrent._lblmessage.setText(BA.ObjectToCharSequence(_msg));
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
public static boolean  _right_ontouch(Object _viewtag,int _action,float _x,float _y,Object _motionevent) throws Exception{
String _b = "";
 //BA.debugLineNum = 120;BA.debugLine="Sub Right_OnTouch( viewtag As Object, action As In";
 //BA.debugLineNum = 121;BA.debugLine="Select action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 123;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 124;BA.debugLine="b=\"RIGHT\"";
_b = "RIGHT";
 //BA.debugLineNum = 125;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
case 1: {
 //BA.debugLineNum = 127;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 128;BA.debugLine="b=\"OFF\"";
_b = "OFF";
 //BA.debugLineNum = 129;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
}
;
 //BA.debugLineNum = 131;BA.debugLine="btnRight.Invalidate";
mostCurrent._btnright.Invalidate();
 //BA.debugLineNum = 132;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 133;BA.debugLine="End Sub";
return false;
}
public static String  _setstate() throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Public Sub SetState";
 //BA.debugLineNum = 53;BA.debugLine="tbtLED.Enabled = Starter.connected";
mostCurrent._tbtled.setEnabled(mostCurrent._starter._connected /*boolean*/ );
 //BA.debugLineNum = 54;BA.debugLine="btnConnect.Enabled = Not(Starter.connected)";
mostCurrent._btnconnect.setEnabled(anywheresoftware.b4a.keywords.Common.Not(mostCurrent._starter._connected /*boolean*/ ));
 //BA.debugLineNum = 55;BA.debugLine="ProgressBar1.Visible = Starter.connecting";
mostCurrent._progressbar1.setVisible(mostCurrent._starter._connecting /*boolean*/ );
 //BA.debugLineNum = 56;BA.debugLine="If Starter.Connected Then";
if (mostCurrent._starter._connected /*boolean*/ ) { 
 //BA.debugLineNum = 57;BA.debugLine="Status = \"connected\"";
mostCurrent._status = "connected";
 }else if(mostCurrent._starter._trytoconnect /*boolean*/ ) { 
 //BA.debugLineNum = 59;BA.debugLine="Status = \"trying to connect...\"";
mostCurrent._status = "trying to connect...";
 }else if(mostCurrent._starter._connecting /*boolean*/ ) { 
 //BA.debugLineNum = 61;BA.debugLine="Status = \"HC-06 found connecting...\"";
mostCurrent._status = "HC-06 found connecting...";
 }else {
 //BA.debugLineNum = 63;BA.debugLine="Status = \"disconnected\"";
mostCurrent._status = "disconnected";
 };
 //BA.debugLineNum = 65;BA.debugLine="lblStatus.Text = $\"Status: ${Status}\"$";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence(("Status: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(mostCurrent._status))+"")));
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _tbtled_checkedchange(boolean _checked) throws Exception{
byte _b = (byte)0;
 //BA.debugLineNum = 72;BA.debugLine="Sub tbtLED_CheckedChange(Checked As Boolean)";
 //BA.debugLineNum = 73;BA.debugLine="Dim b As Byte";
_b = (byte)0;
 //BA.debugLineNum = 74;BA.debugLine="If Checked = True Then";
if (_checked==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 75;BA.debugLine="b = 1";
_b = (byte) (1);
 }else {
 //BA.debugLineNum = 77;BA.debugLine="b = 0";
_b = (byte) (0);
 };
 //BA.debugLineNum = 79;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{_b}));
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static boolean  _up_ontouch(Object _viewtag,int _action,float _x,float _y,Object _motionevent) throws Exception{
String _b = "";
 //BA.debugLineNum = 88;BA.debugLine="Sub Up_OnTouch( viewtag As Object, action As Int,";
 //BA.debugLineNum = 89;BA.debugLine="Select action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_UP)) {
case 0: {
 //BA.debugLineNum = 91;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 92;BA.debugLine="b=\"UP\"";
_b = "UP";
 //BA.debugLineNum = 93;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
case 1: {
 //BA.debugLineNum = 95;BA.debugLine="Dim b As String";
_b = "";
 //BA.debugLineNum = 96;BA.debugLine="b=\"OFF\"";
_b = "OFF";
 //BA.debugLineNum = 97;BA.debugLine="CallSub2(Starter, \"SendMessage1\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage1",(Object)(_b));
 break; }
}
;
 //BA.debugLineNum = 99;BA.debugLine="btnUp.Invalidate";
mostCurrent._btnup.Invalidate();
 //BA.debugLineNum = 100;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 101;BA.debugLine="End Sub";
return false;
}
}
